package middlewares

import (
	"github.com/labstack/echo/v4"
	"github.com/labstack/echo-contrib/session"
)

func CheckSession(next echo.HandlerFunc) echo.HandlerFunc {
	return func(c echo.Context) error {

		sess, err := session.Get("session", c)

		if err != nil {
			return echo.ErrInternalServerError
		}

		isok, val := sess.Values["logged_in"].(bool)

		if isok && val {
			return next(c)
		}

		return c.Redirect(301, "/login")
	}
}
